<template>
  <v-app class="px-3">
    <div class="report-header">
      <h2>Categories</h2>
    </div>
    <v-expansion-panels>
      <v-expansion-panel>
        <v-expansion-panel-header> Invoices </v-expansion-panel-header>
        <v-expansion-panel-content>
          <v-container>
            <v-row>
              <v-col cols="12" sm="12">
                <v-menu
                  ref="menu"
                  v-model="menu"
                  :close-on-content-click="false"
                  :return-value.sync="date"
                  transition="scale-transition"
                  offset-y
                  min-width="auto"
                >
                  <template v-slot:activator="{ on, attrs }">
                    <v-text-field
                      v-model="date"
                      label="Date Range"
                      prepend-icon="mdi-calendar"
                      readonly
                      range
                      v-bind="attrs"
                      v-on="on"
                    ></v-text-field>
                  </template>
                  <v-date-picker
                    range
                    v-model="date"
                    no-title
                    scrollable
                    @change="changeDatePicker"
                  >
                    <v-spacer></v-spacer>
                    <v-btn text color="primary" @click="menu = false">
                      Cancel
                    </v-btn>
                    <v-btn text color="primary" @click="$refs.menu.save(date)">
                      OK
                    </v-btn>
                  </v-date-picker>
                </v-menu>
              </v-col>
            </v-row>
            <v-row>
              <v-col cols="12" sm="12" lg="6">
                <p>Date Presets</p>
                <v-btn-toggle
                  v-model="toggleDatePresets"
                  @change="clickDatePresetToggle"
                >
                  <v-btn> Last Month </v-btn>
                  <v-btn>Last 6 Months</v-btn>
                  <v-btn>This Year</v-btn>
                  <v-btn>All Time</v-btn>
                </v-btn-toggle>
              </v-col>
            </v-row>
            <v-row v-if="user.role === 'Admin'">
              <v-col>
                <p>Trainers</p>
                <v-btn-toggle v-model="toggleTrainer" mandatory>
                  <v-btn @click="toggleOption = 0"> All Trainers </v-btn>
                  <v-btn> Single Trainer </v-btn>
                </v-btn-toggle>
              </v-col>
            </v-row>
            <v-row v-if="user.role === 'Admin' && toggleTrainer == 1">
              <v-col>
                <v-select
                  :items="trainers"
                  item-text="name"
                  item-value="id"
                  label="trainers"
                  v-model="selectedTrainerId"
                ></v-select>
              </v-col>
            </v-row>
            <v-row>
              <v-col>
                <p>Clients</p>

                <v-btn-toggle
                  v-model="toggleOption"
                  @change="clickClientToggle"
                  mandatory
                >
                  <v-btn>All Clients</v-btn>
                  <v-btn
                    :disabled="user.role === 'Admin' && toggleTrainer === 0"
                    >Single Client</v-btn
                  >
                </v-btn-toggle>
              </v-col>
            </v-row>
            <v-row>
              <v-col cols="12" sm="12" lg="6" v-if="toggleOption == 1">
                <v-select
                  v-if="user.role === 'Trainer'"
                  :items="clientSelectOptions"
                  item-text="name"
                  item-value="id"
                  label=" Your Clients"
                  v-model="selectedClientId"
                />
                <v-select
                  v-if="user.role === 'Admin'"
                  :items="trainersClientsSelectOptions"
                  item-text="name"
                  item-value="id"
                  label=" Your Clients"
                  v-model="selectedClientId"
                />
              </v-col>
            </v-row>
            <br />
            <v-row>
              <v-col>
                <v-btn color="primary" @click="generateInvoiceTable">
                  Generate Report
                </v-btn>
              </v-col>
            </v-row>
          </v-container>
          <v-row v-if="showReport">
            <v-col sm="12">
              <v-card>
                <v-card-title>
                  <download-csv
                    class="btn btn-default"
                    :data="invoices"
                    name="invoiceReport.csv"
                    :fields="fields"
                  >
                    Download CSV
                  </download-csv>
                </v-card-title>
                <v-data-table
                  :loading="loading"
                  :headers="headers"
                  :items="invoices"
                ></v-data-table>
              </v-card>
            </v-col>
          </v-row>
        </v-expansion-panel-content>
      </v-expansion-panel>
    </v-expansion-panels>
  </v-app>
</template>

<script>
import invoiceController from "../controllers/invoice.controller";
import client from "../controllers/client.controller";
import trainer from "../controllers/trainer.controller";
import moment from "moment";
import swal from "sweetalert2";
import trainerController from "../controllers/trainer.controller";
export default {
  name: "Report",
  data: () => ({
    invoices: [],
    filteredInvoices: [],
    headers: [
      {
        text: "Invoice ID",
        align: "start",
        sortable: true,
        value: "invoiceId",
      },
      { text: "Client name", value: "clientName" },
      { text: "issueDate", value: "issueDate" },
      { text: "Due date", value: "dueDate" },
      { text: "Quantity", value: "totalQuantity" },
      { text: "Price", value: "totalPrice" },
    ],
    date: null,
    menu: false,
    toggleOption: 0,
    allClients: [],
    selectedClientId: null,
    showReport: false,
    toggleDatePresets: null,
    toggleTrainer: 0,
    cutoff: null,
    selectedTrainerId: null,
    trainers: [],
    fields: [
      "invoiceId",
      "clientID",
      "clientName",
      "trainerId",
      "trainerName",
      "issueDate",
      "dueDate",
      "status",
    ],
    loading: true,
  }),
  computed: {
    user() {
      return this.$store.getters.getAuthUser;
    },
    clientSelectOptions() {
      return this.allClients.map((client) => {
        return {
          name: client.firstName + " " + client.lastName,
          id: client.clientId,
        };
      });
    },
    trainersClient() {
      return this.allClients.filter(
        (client) => client.trainerId === this.selectedTrainerId
      );
    },
    trainersClientsSelectOptions() {
      return this.trainersClient.map((client) => {
        return {
          name: client.firstName + " " + client.lastName,
          id: client.clientId,
        };
      });
    },
  },
  methods: {
    async getInvoices(start, end) {
      this.invoices = [];
      this.loading = true;
      try {
        let res;
        if (this.toggleOption == 1) {
          if (this.user.role === "Admin") {
            res = await invoiceController.getTrainersInvoices(this.selectedTrainerId);
          } else {
            res = await invoiceController.getTrainersInvoices(this.user.trainerId);
          }
          if (res) {
            this.invoices = res.filter((invoice) => {
              invoice.issueDate = invoice.issueDate.substring(0, 10);
              invoice.dueDate = invoice.dueDate.substring(0, 10);
              invoice.totalQuantity = 0;
              invoice.totalPrice = 0;
              invoice.invoiceLines.forEach((line) => {
                invoice.totalPrice += line.price;
                invoice.totalQuantity += line.quantity;
              });
              return (
                invoice.clientId == this.selectedClientId &&
                moment(invoice.issueDate).isAfter(start) &&
                moment(invoice.issueDate).isBefore(end)
              );
            });
          }
        } else {
          if (this.user.role === "Admin" && this.toggleTrainer == 0) {
            res = await (await invoiceController.getInvoicesDetail()).data;
          } else if (this.user.role === "Admin" && this.toggleTrainer == 1) {
            res = await invoiceController.getTrainersInvoices(this.selectedTrainerId);
          } else {
            res = await invoiceController.getTrainersInvoices(this.user.trainerId);
          }
          this.invoices = res.filter((invoice) => {
            invoice.issueDate = invoice.issueDate.substring(0, 10);
            invoice.dueDate = invoice.dueDate.substring(0, 10);
            invoice.totalPrice = 0;
            invoice.totalQuantity = 0;
            invoice.invoiceLines.forEach((line) => {
              invoice.totalPrice += line.price * line.quantity;
              invoice.totalQuantity += line.quantity;
            });
            return (
              moment(invoice.issueDate).isAfter(start) &&
              moment(invoice.issueDate).isBefore(end)
            );
          });
        }
      } catch (error) {
        console.log(error);
      }
      this.loading = false;
    },
    generateInvoiceTable() {
      if (this.toggleDatePresets == null && this.date == null) {
        swal.fire("Please either select date range or date preset");
        return;
      }
      let cutoff;
      if (this.toggleDatePresets != null) {
        switch (this.toggleDatePresets) {
          case 0:
            cutoff = moment().subtract(1, "month");
            break;
          case 1:
            cutoff = moment().subtract(6, "months");
            break;
          case 2:
            cutoff = moment().subtract(1, "year");
            break;
          case 3:
            cutoff = moment("1999-01-01");
            break;
          default:
            cutoff = moment().subtract(200, "years");
            break;
        }
        this.getInvoices(cutoff, moment());
      } else {
        const sorted = this.date.sort();
        this.getInvoices(moment(sorted[0]), moment(sorted[1]));
      }
      this.showReport = true;
    },
    clickDatePresetToggle(event) {
      if (event >= 0) {
        this.date = "";
      }
    },
    changeDatePicker(event) {
      if (event) {
        this.toggleDatePresets = null;
      }
    },
    clickClientToggle() {
      this.showReport = false;
    },

    async getAllTrainers() {
      try {
        const trainers = await trainerController.getTrainers();
        if (trainers) {
          const filteredTrainers = trainers.filter((trainer) => {
            return trainer.activationStatus === "Accepted";
          });
          this.trainers = filteredTrainers.map((trainer) => {
            return {
              name: trainer.firstName + " " + trainer.lastName,
              id: trainer.trainerId,
            };
          });
        } else {
          swal.fire("Something went wrong", "Could not get trainers", "error");
        }
      } catch (e) {
        console.log(e);
        swal.fire("Something went wrong", "Could not get trainers", "error");
      }
    },
  },
  async mounted() {
    if (this.user.role === "Admin") {
      await this.getAllTrainers();
    }
    try {
      let allClients;
      if (this.user.role == "Admin") {
        allClients = await client.getAllClients();
      } else {
        allClients = await trainer.getTrainersClients(this.user.trainerId);
      }
      if (allClients) {
        if (allClients.data) {
          this.allClients = allClients.data;
        } else {
          this.allClients = allClients;
        }
      }
    } catch (error) {
      console.log(error);
    }
  },
};
</script>

<style scoped>
.report-header {
  margin: 2em;
}
</style>